| Flutter Linux Embedder |

Classes | Macros | Enumerations | Functions | Variables
fl_application.cc File Reference
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_application.h"`
`#include <gtk/gtk.h>`
`#include "flutter/shell/platform/linux/fl_engine_private.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_dart_project.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_plugin_registry.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_view.h"`

Go to the source code of this file.

## Classes
struct | FlApplicationPrivate

## Macros
#define | FL_APPLICATION_GET_PRIVATE(app)

## Enumerations
enum | { SIGNAL_REGISTER_PLUGINS , SIGNAL_CREATE_WINDOW , LAST_SIGNAL }

## Functions
| G_DEFINE_TYPE_WITH_CODE (FlApplication, fl_application, GTK_TYPE_APPLICATION, G_ADD_PRIVATE(FlApplication)) static GtkWindow *create_window_cb(FlApplication *self
| g_signal_emit (self, fl_application_signals[SIGNAL_CREATE_WINDOW], 0, view, &window)
static void | first_frame_cb (FlApplication *self, FlView *view)
static void | fl_application_register_plugins (FlApplication *self, FlPluginRegistry *registry)
static GtkWindow * | fl_application_create_window (FlApplication *self, FlView *view)
static void | fl_application_activate (GApplication *application)
static gboolean | fl_application_local_command_line (GApplication *application, gchar ***arguments, int *exit_status)
static void | fl_application_dispose (GObject *object)
static void | fl_application_class_init (FlApplicationClass *klass)
static void | fl_application_init (FlApplication *self)
G_MODULE_EXPORT FlApplication * | fl_application_new (const gchar *application_id, GApplicationFlags flags)

## Variables
static guint | fl_application_signals [LAST_SIGNAL]
FlView * | view
return | window

## Macro Definition Documentation

## ◆ FL_APPLICATION_GET_PRIVATE

#define FL_APPLICATION_GET_PRIVATE | ( |  | app | ) |

Value:
((FlApplicationPrivate*)fl_application_get_instance_private( \
FL_APPLICATION(app)))
FlApplicationPrivate
Definition: fl_application.cc:17

Definition at line 22 of file fl_application.cc.

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
SIGNAL_REGISTER_PLUGINS |
SIGNAL_CREATE_WINDOW |
LAST_SIGNAL |

Definition at line 26 of file fl_application.cc.

26 { SIGNAL_REGISTER_PLUGINS, SIGNAL_CREATE_WINDOW, LAST_SIGNAL };
LAST_SIGNAL
@ LAST_SIGNAL
Definition: fl_application.cc:26
SIGNAL_CREATE_WINDOW
@ SIGNAL_CREATE_WINDOW
Definition: fl_application.cc:26
SIGNAL_REGISTER_PLUGINS
@ SIGNAL_REGISTER_PLUGINS
Definition: fl_application.cc:26

## Function Documentation

## ◆ first_frame_cb()

static void first_frame_cb | ( | FlApplication * | self,
|  | FlView * | view
| ) |  |
| static

Definition at line 45 of file fl_application.cc.

45 {
46 GtkWidget* window = gtk_widget_get_toplevel(GTK_WIDGET(view));
47
48 // Show the main window.
49 if (window != nullptr && GTK_IS_WINDOW(window)) {
50 gtk_window_present(GTK_WINDOW(window));
51 }
52 }
view
FlView * view
Definition: fl_application.cc:36
window
return window
Definition: fl_application.cc:41

References view, and window.

Referenced by fl_application_activate().

## ◆ fl_application_activate()

static void fl_application_activate | ( | GApplication * | application | ) |
| static

Definition at line 94 of file fl_application.cc.

94 {
95 FlApplication* self = FL_APPLICATION(application);
96 FlApplicationPrivate* priv = FL_APPLICATION_GET_PRIVATE(self);
97
98 g_autoptr(FlDartProject) project = fl_dart_project_new();
99 fl_dart_project_set_dart_entrypoint_arguments(
100 project, priv->dart_entrypoint_arguments);
101
102 FlView* view = fl_view_new(project);
103 g_signal_connect_swapped(view, "first-frame", G_CALLBACK(first_frame_cb),
104 self);
105 gtk_widget_show(GTK_WIDGET(view));
106
107 FlWindowingHandler* windowing_handler =
108 fl_engine_get_windowing_handler(fl_view_get_engine(view));
109 g_signal_connect_swapped(windowing_handler, "create_window",
110 G_CALLBACK(create_window_cb), self);
111
112 GtkWindow* window;
113 g_signal_emit(self, fl_application_signals[SIGNAL_CREATE_WINDOW], 0, view,
114 &window);
115
116 // Make the resources for the view so rendering can start.
117 // We'll show the view when we have the first frame.
118 gtk_widget_realize(GTK_WIDGET(view));
119
120 g_signal_emit(self, fl_application_signals[SIGNAL_REGISTER_PLUGINS], 0,
121 FL_PLUGIN_REGISTRY(view));
122 }
first_frame_cb
static void first_frame_cb(FlApplication *self, FlView *view)
Definition: fl_application.cc:45
fl_application_signals
static guint fl_application_signals[LAST_SIGNAL]
Definition: fl_application.cc:28
FL_APPLICATION_GET_PRIVATE
#define FL_APPLICATION_GET_PRIVATE(app)
Definition: fl_application.cc:22
g_signal_emit
g_signal_emit(self, fl_application_signals[SIGNAL_CREATE_WINDOW], 0, view, &window)
g_autoptr
g_autoptr(GMutexLocker) locker
fl_dart_project_new
G_MODULE_EXPORT FlDartProject * fl_dart_project_new()
Definition: fl_dart_project.cc:52
fl_dart_project_set_dart_entrypoint_arguments
G_MODULE_EXPORT void fl_dart_project_set_dart_entrypoint_arguments(FlDartProject *self, char **argv)
Definition: fl_dart_project.cc:112
fl_engine_get_windowing_handler
FlWindowingHandler * fl_engine_get_windowing_handler(FlEngine *self)
Definition: fl_engine.cc:1494
priv
FlPixelBufferTexturePrivate * priv
Definition: fl_pixel_buffer_texture.cc:30
fl_view_new
G_MODULE_EXPORT FlView * fl_view_new(FlDartProject *project)
Definition: fl_view.cc:763
fl_view_get_engine
G_MODULE_EXPORT FlEngine * fl_view_get_engine(FlView *self)
Definition: fl_view.cc:790

References first_frame_cb(), FL_APPLICATION_GET_PRIVATE, fl_application_signals, fl_dart_project_new(), fl_dart_project_set_dart_entrypoint_arguments(), fl_engine_get_windowing_handler(), fl_view_get_engine(), fl_view_new(), g_autoptr(), g_signal_emit(), priv, SIGNAL_CREATE_WINDOW, SIGNAL_REGISTER_PLUGINS, view, and window.

Referenced by fl_application_class_init().

## ◆ fl_application_class_init()

static void fl_application_class_init | ( | FlApplicationClass * | klass | ) |
| static

Definition at line 159 of file fl_application.cc.

159 {
160 G_APPLICATION_CLASS(klass)->activate = fl_application_activate;
161 G_APPLICATION_CLASS(klass)->local_command_line =
162 fl_application_local_command_line;
163 G_OBJECT_CLASS(klass)->dispose = fl_application_dispose;
164
165 klass->register_plugins = fl_application_register_plugins;
166 klass->create_window = fl_application_create_window;
167
168 fl_application_signals[SIGNAL_REGISTER_PLUGINS] = g_signal_new(
169 "register-plugins", fl_application_get_type(), G_SIGNAL_RUN_LAST,
170 G_STRUCT_OFFSET(FlApplicationClass, register_plugins), nullptr, nullptr,
171 nullptr, G_TYPE_NONE, 1, fl_plugin_registry_get_type());
172 fl_application_signals[SIGNAL_CREATE_WINDOW] = g_signal_new(
173 "create-window", fl_application_get_type(), G_SIGNAL_RUN_LAST,
174 G_STRUCT_OFFSET(FlApplicationClass, create_window),
175 g_signal_accumulator_first_wins, nullptr, nullptr, GTK_TYPE_WINDOW, 1,
176 fl_view_get_type());
177 }
fl_application_dispose
static void fl_application_dispose(GObject *object)
Definition: fl_application.cc:150
fl_application_local_command_line
static gboolean fl_application_local_command_line(GApplication *application, gchar ***arguments, int *exit_status)
Definition: fl_application.cc:125
fl_application_create_window
static GtkWindow * fl_application_create_window(FlApplication *self, FlView *view)
Definition: fl_application.cc:59
fl_application_register_plugins
static void fl_application_register_plugins(FlApplication *self, FlPluginRegistry *registry)
Definition: fl_application.cc:55
fl_application_activate
static void fl_application_activate(GApplication *application)
Definition: fl_application.cc:94

References fl_application_activate(), fl_application_create_window(), fl_application_dispose(), fl_application_local_command_line(), fl_application_register_plugins(), fl_application_signals, SIGNAL_CREATE_WINDOW, and SIGNAL_REGISTER_PLUGINS.

## ◆ fl_application_create_window()

static GtkWindow* fl_application_create_window | ( | FlApplication * | self,
|  | FlView * | view
| ) |  |
| static

Definition at line 59 of file fl_application.cc.

60 {
61 GtkApplicationWindow* window =
62 GTK_APPLICATION_WINDOW(gtk_application_window_new(GTK_APPLICATION(self)));
63
64 // Use a header bar when running in GNOME as this is the common style used
65 // by applications and is the setup most users will be using (e.g. Ubuntu
66 // desktop).
67 // If running on X and not using GNOME then just use a traditional title bar
68 // in case the window manager does more exotic layout, e.g. tiling.
69 // If running on Wayland assume the header bar will work (may need changing
70 // if future cases occur).
71 gboolean use_header_bar = TRUE;
72 #ifdef GDK_WINDOWING_X11
73 GdkScreen* screen = gtk_window_get_screen(GTK_WINDOW(window));
74 if (GDK_IS_X11_SCREEN(screen)) {
75 const gchar* wm_name = gdk_x11_screen_get_window_manager_name(screen);
76 if (g_strcmp0(wm_name, "GNOME Shell") != 0) {
77 use_header_bar = FALSE;
78 }
79 }
80 #endif
81 if (use_header_bar) {
82 GtkHeaderBar* header_bar = GTK_HEADER_BAR(gtk_header_bar_new());
83 gtk_widget_show(GTK_WIDGET(header_bar));
84 gtk_header_bar_set_show_close_button(header_bar, TRUE);
85 gtk_window_set_titlebar(GTK_WINDOW(window), GTK_WIDGET(header_bar));
86 }
87
88 gtk_container_add(GTK_CONTAINER(window), GTK_WIDGET(view));
89
90 return GTK_WINDOW(window);
91 }
TRUE
return TRUE
Definition: fl_compositor_software.cc:68

References TRUE, view, and window.

Referenced by fl_application_class_init().

## ◆ fl_application_dispose()

static void fl_application_dispose | ( | GObject * | object | ) |
| static

Definition at line 150 of file fl_application.cc.

150 {
151 FlApplication* self = FL_APPLICATION(object);
152 FlApplicationPrivate* priv = FL_APPLICATION_GET_PRIVATE(self);
153
154 g_clear_pointer(&priv->dart_entrypoint_arguments, g_strfreev);
155
156 G_OBJECT_CLASS(fl_application_parent_class)->dispose(object);
157 }

References FL_APPLICATION_GET_PRIVATE, and priv.

Referenced by fl_application_class_init().

## ◆ fl_application_init()

static void fl_application_init | ( | FlApplication * | self | ) |
| static

Definition at line 179 of file fl_application.cc.

179 {}

## ◆ fl_application_local_command_line()

static gboolean fl_application_local_command_line | ( | GApplication * | application,
|  | gchar *** | arguments,
|  | int * | exit_status
| ) |  |
| static

Definition at line 125 of file fl_application.cc.

127 {
128 FlApplication* self = FL_APPLICATION(application);
129 FlApplicationPrivate* priv = FL_APPLICATION_GET_PRIVATE(self);
130
131 // Strip out the first argument as it is the binary name.
132 priv->dart_entrypoint_arguments = g_strdupv(*arguments + 1);
133
134 g_autoptr(GError) error = nullptr;
135 if (!g_application_register(application, nullptr, &error)) {
136 g_warning("Failed to register: %s", error->message);
137 *exit_status = 1;
138 return TRUE;
139 }
140
141 // This will only run on the primary instance or this instance with
142 // G_APPLICATION_NON_UNIQUE
143 g_application_activate(application);
144 *exit_status = 0;
145
146 return TRUE;
147 }
error
const uint8_t uint32_t uint32_t GError ** error
Definition: fl_pixel_buffer_texture_test.cc:40

References error, FL_APPLICATION_GET_PRIVATE, g_autoptr(), priv, and TRUE.

Referenced by fl_application_class_init().

## ◆ fl_application_new()

G_MODULE_EXPORT FlApplication* fl_application_new | ( | const gchar * | application_id,
|  | GApplicationFlags | flags
| ) |  |

FlApplication:

#Flutter-based application with the GTK embedder.

Provides default behaviour for basic Flutter applications. fl_application_new: @application_id: (allow-none): The application ID or NULL. @flags: The application flags.

Creates a new Flutter-based application.

Returns: a new #FlApplication

Definition at line 182 of file fl_application.cc.

183 {
184 return FL_APPLICATION(g_object_new(fl_application_get_type(),
185 "application-id", application_id, "flags",
186 flags, nullptr));
187 }

Referenced by TEST().

## ◆ fl_application_register_plugins()

static void fl_application_register_plugins | ( | FlApplication * | self,
|  | FlPluginRegistry * | registry
| ) |  |
| static

Definition at line 55 of file fl_application.cc.

56 {}

Referenced by fl_application_class_init().

## ◆ G_DEFINE_TYPE_WITH_CODE()

G_DEFINE_TYPE_WITH_CODE | ( | FlApplication | ,
|  | fl_application | ,
|  | GTK_TYPE_APPLICATION | ,
|  | G_ADD_PRIVATE(FlApplication) |
| ) |  |

## ◆ g_signal_emit()

g_signal_emit | ( | self | ,
|  | fl_application_signals | [SIGNAL_CREATE_WINDOW],
|  | 0 | ,
|  | view | ,
|  | & | window
| ) |  |

Referenced by activate_system_cursor(), create_regular(), fl_application_activate(), fl_engine_on_pre_engine_restart_cb(), fl_engine_update_semantics_cb(), fl_settings_emit_changed(), and G_DEFINE_TYPE_WITH_CODE().

## Variable Documentation

## ◆ fl_application_signals

guint fl_application_signals[LAST_SIGNAL]
| static

Definition at line 28 of file fl_application.cc.

Referenced by fl_application_activate(), and fl_application_class_init().

## ◆ view

FlView* view

Initial value:
{
GtkWindow* window

Definition at line 36 of file fl_application.cc.

Referenced by create_regular(), first_frame_cb(), fl_application_activate(), fl_application_create_window(), fl_plugin_registrar_new(), fl_windowing_handler_create_window(), G_DECLARE_FINAL_TYPE(), G_DEFINE_TYPE_WITH_PRIVATE(), get_view(), TEST(), and window_data_new().

## ◆ window

return window

Definition at line 41 of file fl_application.cc.

Referenced by create_regular(), cursor_changed_cb(), first_frame_cb(), fl_application_activate(), fl_application_create_window(), fl_compositor_opengl_render(), fl_compositor_render(), fl_compositor_software_render(), fl_window_monitor_new(), fl_window_state_monitor_new(), fl_windowing_handler_create_window(), G_DEFINE_TYPE_WITH_PRIVATE(), handle_geometry_changed(), quit_application(), TEST(), and window_data_new().